
Core - Bug # 53682

Status: Resolved Priority: Must have
Author: Jost Baron Category: Backend API
Created: 2013-11-15 Assigned To:
Updated: 2014-10-22 Due date:
TYPO3 Version: 4.5
PHP Version: 5.5
Complexity:
Is Regression: No
Sprint Focus:
Subject: Exception '$toolbarItem "shortcuts" must implement interface ...\ToolbarItemHookInterface'
Description

The backend does not work with PHP 5.5.6 anymore. The exception thrown is this one:

$toolbarItem "shortcuts" must implement interface TYPO3\CMS\Backend\Toolbar\ToolbarItemHookInterface

To reproduce, create a new 6.2 installation using the wizard in the install tool, and run it on PHP 5.5.6.

This does not happen on PHP 5.5.5 or 5.4.22, I have not tested other versions. Ernesto Baschny pointed out that this problem
occurred with PHP 5.3.3 too, maybe that info helps?

Link to the PHP bug tracker:https://bugs.php.net/bug.php?id=66107

The following classes are affected:

    -  typo3/sysext/backend/Classes/Toolbar/ToolbarItemHookInterface 
    -  typo3/sysext/backend/Classes/Toolbar/ShortcutToolbarItem 
    -  typo3/sysext/backend/Classes/Toolbar/LiveSearchToolbarItem 
    -  typo3/sysext/backend/Classes/Toolbar/ClearCacheToolbarItem 
    -  typo3/sysext/backend/Classes/Form/Element/TreeElement.php
    -  typo3/sysext/workspaces/Classes/ExtDirect/WorkspaceSelectorToolbarItem.php
    -  typo3/sysext/opendocs/Classes/Controller/OpendocsController.php
    -  typo3/sysext/sys_action/Classes/ActionToolbarMenu.php

To solve the issue temporarily you need to modify the constructor of those classes by removing the reference operator (&) of all
referenced class parameters.

1public function __construct(SomeClassNameHere &$backendReference = NULL)

1public function __construct(SomeClassNameHere $backendReference = NULL)

Related issues:
related to Core - Feature # 17795: add the workspace selector to the cleaner ... Closed 2007-11-15
related to Core - Bug # 33416: Exception thrown by tslib_content->getContentO... Closed 2012-01-24
related to Core - Bug # 62391: TYPO3 4.5.37 requires PHP 5.3 Resolved 2014-10-22
related to Core - Bug # 55811: Namespace usage in 4.7 Resolved 2014-02-09
related to Core - Bug # 54425: TYPO3\CMS\Frontend\ContentObject\ContentObject... Resolved 2013-12-15
duplicated by Core - Bug # 53777: Exception: $toolbarItem "shortcuts" must im... Closed 2013-11-20
duplicated by Core - Bug # 53754: Failure in backend with php-5.5.6 Closed 2013-11-19
Associated revisions
Revision 6eb7a548 - 2013-12-14 22:24 - Helmut Hummel

[TASK] Optimize speed for instantiating class with arguments

PHP reflection has quite an overhead in performance.
Use a switch construct like in Flow instead to
instantiate classes with up to 8 arguments without
reflection.

Resolves: #53682
Releases: 6.2, 6.1, 6.0
Change-Id: I82ecf0b1ea9a412a39b4429d7689f2bb6489f3df
Reviewed-on: https://review.typo3.org/26363
Reviewed-by: Philipp Gampe
Tested-by: Philipp Gampe
Reviewed-by: Markus Klein
Reviewed-by: Stefan Neufeind
Tested-by: Stefan Neufeind

Revision 67ac84c0 - 2014-01-04 16:49 - Helmut Hummel

[TASK] Optimize speed for instantiating class with arguments

PHP reflection has quite an overhead in performance.
Use a switch construct like in Flow instead to
instantiate classes with up to 8 arguments without
reflection.

Resolves: #53682
Releases: 6.2, 6.1, 6.0
Change-Id: I82ecf0b1ea9a412a39b4429d7689f2bb6489f3df
Reviewed-on: https://review.typo3.org/26413
Reviewed-by: Markus Klein
Tested-by: Markus Klein

Revision dd187dd1 - 2014-01-04 16:50 - Helmut Hummel

[TASK] Optimize speed for instantiating class with arguments

PHP reflection has quite an overhead in performance.
Use a switch construct like in Flow instead to
instantiate classes with up to 8 arguments without
reflection.

Resolves: #53682
Releases: 6.2, 6.1, 6.0
Change-Id: I82ecf0b1ea9a412a39b4429d7689f2bb6489f3df
Reviewed-on: https://review.typo3.org/26414
Reviewed-by: Markus Klein

2015-08-04 2/13

https://review.typo3.org/26363
https://review.typo3.org/26413
https://review.typo3.org/26414


Tested-by: Markus Klein

Revision 3d40e0ac - 2014-01-17 09:25 - Helmut Hummel

[TASK] Optimize speed for instantiating class with arguments

PHP reflection has quite an overhead in performance.
Use a switch construct like in Flow instead to
instantiate classes with up to 8 arguments without
reflection.

Resolves: #53682
Releases: 6.2, 6.1, 6.0, 4.7, 4.5
Change-Id: I82ecf0b1ea9a412a39b4429d7689f2bb6489f3df
Reviewed-on: https://review.typo3.org/26416
Reviewed-by: Markus Klein
Reviewed-by: Oliver Klee
Reviewed-by: Ingo Pfennigstorf
Tested-by: Ingo Pfennigstorf
Reviewed-by: Stefan Neufeind
Tested-by: Stefan Neufeind

Revision 2526bddb - 2014-01-17 09:28 - Helmut Hummel

[TASK] Optimize speed for instantiating class with arguments

PHP reflection has quite an overhead in performance.
Use a switch construct like in Flow instead to
instantiate classes with up to 8 arguments without
reflection.

Resolves: #53682
Releases: 6.2, 6.1, 6.0, 4.7, 4.5
Change-Id: I82ecf0b1ea9a412a39b4429d7689f2bb6489f3df
Reviewed-on: https://review.typo3.org/26643
Reviewed-by: Markus Klein
Reviewed-by: Stefan Neufeind
Tested-by: Stefan Neufeind

Revision df8e21b7 - 2014-02-09 14:28 - Christian Kuhn

[BUGFIX] Namespace usage in test

Patch for issue #31998 introduced a namespace in unit test,
the test suite now fails after patch for issue #53682. Use
old class name instead.

Change-Id: I83e7cd33787364c1f531c51406f09884aff418c6
Resolves: #55811
Related: #53682
Related: #31998
Releases: 4.7, 4.5
Reviewed-on: https://review.typo3.org/27513
Reviewed-by: Christian Kuhn
Tested-by: Christian Kuhn

Revision 7d6a8cc7 - 2014-02-09 14:28 - Christian Kuhn

[BUGFIX] Namespace usage in test

Patch for issue #31998 introduced a namespace in unit test,
the test suite now fails after patch for issue #53682. Use
old class name instead.

Change-Id: I83e7cd33787364c1f531c51406f09884aff418c6
Resolves: #55811
Related: #53682
Related: #31998
Releases: 4.7, 4.5
Reviewed-on: https://review.typo3.org/27513
Reviewed-by: Christian Kuhn
Tested-by: Christian Kuhn
(cherry picked from commit df8e21b7e727d7ec709ed9f92e3069d77db0be04)
Reviewed-on: https://review.typo3.org/27514

Revision 5c8081ad - 2014-10-14 23:15 - Helmut Hummel

[TASK] Optimize speed for instantiating class with arguments

PHP reflection has quite an overhead in performance.
Use a switch construct like in Flow instead to
instantiate classes with up to 8 arguments without
reflection.

Resolves: #53682
Releases: 6.2, 6.1, 6.0, 4.7, 4.5
Change-Id: I8ab21fa5ae609fc4653205f4b53c51ed61618ea7
Reviewed-on: http://review.typo3.org/33308
Reviewed-by: Wouter Wolters <typo3@wouterwolters.nl>
Reviewed-by: Markus Klein <klein.t3@reelworx.at>
Tested-by: Wouter Wolters <typo3@wouterwolters.nl>
Reviewed-by: Stefan Neufeind <typo3.neufeind@speedpartner.de>
Tested-by: Stefan Neufeind <typo3.neufeind@speedpartner.de>

History
#1 - 2013-11-16 17:32 - Markus Klein
- Category set to Backend API
- Target version set to next-patchlevel
- PHP Version set to 5.5
Where does it occur exactly? This can happen in Core at two places?
The exception codes are:
    -  1195126772, BackendController:152
    -  1195125501, BackendController:679

#2 - 2013-11-16 19:21 - Jeff Segars

I noticed the same error yesterday, thrown inside \TYPO3\CMS\Backend\Controller\BackendController->initializeCoreToolbarItems().  I've seen it on
4.7, 6.0, and 6.2 (haven't tested 4.5 or 6.1 yet).  When I downgrade to PHP 5.5.5 the issue goes away.

From my initial investigation, the problem is in some way connected to using reflection and constructor arguments when creating the instance of the
toolbar item.  Inside initializeCoreToolbarItems, we have a call to makeInstance(), passing along $this as a constructor argument.  Inside
makeInstance(), reflection is used when handling arguments. At line 4179 of \TYPO3\CMS\Core\Utility\GeneralUtility we have "$instance =
$reflectedClass->newInstanceArgs($constructorArguments)" which returns null.  If I switch it to newInstance() instead, I get a valid object back.

That's about as far as I've made it in debugging for now, but maybe some of that info is helpful.

#3 - 2013-11-17 19:42 - Alexander Bigga

Same problem here on current Arch Linux:

    -  PHP 5.5.6
    -  TYPO3 6.1.5 (introduction package)

#1195126772: $toolbarItem "shortcuts" must implement interface TYPO3\CMS\Backend\Toolbar\ToolbarItemHookInterface (More information)

UnexpectedValueException thrown in file
/[...]/typo3_src-6.1.5/typo3/sysext/backend/Classes/Controller/BackendController.php in line 148.

I was looking for an explanation and never had PHP in mind :-(

Alexander

#4 - 2013-11-19 14:27 - Markus Klein
- Status changed from New to Accepted
- TYPO3 Version changed from 6.2 to 4.5

Joerg Neikes wrote:

graphicsmagic does not work too.

With php 5.5.5 all works fine.

May be a wrong bug fix in php update.

The running system is a gentoo ~x64 distributon with updates from 18.11.2013.
#5 - 2013-11-20 02:03 - Markus Klein

Related bug report:https://bugs.php.net/bug.php?id=66107

#6 - 2013-11-26 22:55 - Ernesto Baschny

See also discussion in this "Tweet" (!!):

https://twitter.com/SwiftLizard/status/405419858864533504

#7 - 2013-11-26 23:30 - Markus Klein

The reference in the constructor was introduced with #17795

#8 - 2013-11-27 00:09 - Chris Zepernick
- File test.php added

The Problem does not only occur in TYPO3 Version 4.x but also 6.x.
The Bug is not caused by TYPO3 but by PHP ReflectionClass::newInstanceArgs($array); 
If a parameter is passed by reference the Bug occurs.

The Bug can be avoided in this case by altering :

    -  typo3_src/typo3/sysext/backend/Classes/Toolbar/ToolbarItemHookInterface 
    -  typo3_src/typo3/sysext/backend/Classes/Toolbar/ShortcutToolbarItem 
    -  typo3_src/typo3/sysext/backend/Classes/Toolbar/LiveSearchToolbarItem 
    -  typo3_src/typo3/sysext/backend/Classes/Toolbar/ClearCacheToolbarItem

alter:  "public function __construct(\TYPO3\CMS\Backend\Controller\BackendController *&*$backendReference = NULL)“ 
to: "public function __construct(\TYPO3\CMS\Backend\Controller\BackendController $backendReference = NULL)“

These "pass by reference" are unnecessary since PHP5 because Objects are always passed by reference.

After that change TYPO3 should mostly work as expected.

Little Testcase attached.
Tested with this VagrantBox: https://github.com/swiftlizard/VagrantTYPO3Flow

#9 - 2013-11-29 17:35 - Artus Kolanowski

Chris Zepernick wrote:

The Problem does not only occur in TYPO3 Version 4.x but also 6.x...

Thanks! Helped me to fix a running TYPO3 6.1.5. The Hoster just switched to PHP 5.5.6 without telling anybody...
#10 - 2013-11-29 19:43 - Stefan Neufeind

It seems PHP is not going to fix this in 5.5.7, though I would have expected that because it's a regression. Preliminary changelog for 5.5.7RC1:
https://github.com/php/php-src/blob/php-5.5.7RC1/NEWS

#11 - 2013-11-30 11:40 - Viktor Livakivskyi

Chris Zepernick wrote:

The Bug can be avoided in this case by altering :
    -  typo3_src/typo3/sysext/backend/Classes/Toolbar/ToolbarItemHookInterface 
    -  typo3_src/typo3/sysext/backend/Classes/Toolbar/ShortcutToolbarItem 
    -  typo3_src/typo3/sysext/backend/Classes/Toolbar/LiveSearchToolbarItem 
    -  typo3_src/typo3/sysext/backend/Classes/Toolbar/ClearCacheToolbarItem

alter:  "public function __construct(\TYPO3\CMS\Backend\Controller\BackendController *&*$backendReference = NULL)“ 
to: "public function __construct(\TYPO3\CMS\Backend\Controller\BackendController $backendReference = NULL)“

In my TYPO3 6.0.10 instance I've had also to fix same in these files:    -  
typo3_src/typo3/sysext/workspaces/Classes/ExtDirect/WorkspaceSelectorToolbarItem.php
    -  typo3_src/typo3/sysext/opendocs/Classes/Controller/OpendocsController.php
    -  typo3_src/typo3/sysext/sys_action/Classes/ActionToolbarMenu.php

Because they are using same interface.

#12 - 2013-12-01 00:05 - Artus Kolanowski

Here is the next one:

    -  typo3_src/typo3/sysext/backend/Classes/Form/Element/TreeElement.php

Otherwise I'm not able to edit BE users (Fatal error: Call to a member function renderField() on a non-object in
[...]/typo3_src-6.1.6/typo3/sysext/backend/Classes/Form/FormEngine.php on line 1749).

#13 - 2013-12-06 14:25 - David Bruchmann

Just searching for "&$" in the core including the sysext-folder I found 1346 occurrences in version 6.1.
Some are in comments, some are for arrays, nevertheless the changed behavior of php seems being some work for TYPO3.

#14 - 2013-12-06 14:41 - Frenck Lutke

David Bruchmann wrote:

Just searching for "&$" in the core including the sysext-folder I found 1346 occurrences in version 6.1.
Some are in comments, some are for arrays, nevertheless the changed behavior of php seems being some work for TYPO3.

The only changes needed due to this PHP bug are with references in constructors, of which there are only ~10 occurrences in core (depends on
version), of which most were already mentioned in these comments. These are all objects, so there is no functional difference when changing their
reference declaration.

You can easily confirm, as well as find any offending extensions in your installation, with a simple regular expression: (?<=__construct\()(.*&.+)(?=\))

#15 - 2013-12-07 13:01 - Philipp Gampe
- File php-5.5.6.patch added

Attached is a patch against current master that should work across 6.x. Please not that it breaks any extension that uses the interface to add toolbar
items.

IMHO we should wait for a patch from the PHP.

Hint: use $ git apply php-5.5.6.patch to read in the patch file

#16 - 2013-12-08 03:10 - Philipp Gampe

Same issue in typo3/sysext/backend/Classes/Form/Element/TreeElement.php

#17 - 2013-12-08 11:10 - Markus Klein
- Subject changed from Backend does not work with PHP 5.5.6 to Exception '$toolbarItem "shortcuts" must implement interface 
...\ToolbarItemHookInterface'

#18 - 2013-12-10 20:48 - Markus Klein

Some news from the PHP bug tracker:

I've reverted changes in PHP-5.5 (not in PHP-5.6 and above).

#19 - 2013-12-11 02:24 - Stefan Neufeind

Thanks. So for now we can expect a fixed 5.5.7 some time. But we'll still need the change for 5.6+ then. Planned release for 5.6 is sometime around
August 2014.

http://comments.gmane.org/gmane.comp.php.devel/82450

It's already mid-october and according to our release schedule we have to

release PHP 5.6 in 10 months from now.

#20 - 2013-12-11 10:40 - Markus Klein

Yes we indeed need a fix for TYPO3 as well. It does not make sense to pass the parameters as reference (nowadays) since we don't modify the
variable in our constructors.

IMHO it is best to go with this breaking change now, before the 6.2 release.
#21 - 2013-12-12 00:01 - Philipp Gampe

Related work-around: https://review.typo3.org/#/c/26344/3

#22 - 2013-12-12 00:51 - Gerrit Code Review
- Status changed from Accepted to Under Review

Patch set 4 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/26344

#23 - 2013-12-12 08:53 - Helmut Hummel

Markus Klein wrote:

IMHO it is best to go with this breaking change now, before the 6.2 release.

Why not completely remove the constructor from the interface? That is bad style anyway.

#24 - 2013-12-12 15:08 - Stefan Neufeind

Timetable for PHP 5.6: https://wiki.php.net/todo/php56#timetable
alpha1 in January (so we could start testing), final in June

#25 - 2013-12-12 15:25 - patr no-lastname-given

I have typo3 4.7.17 same problem.

#26 - 2013-12-12 22:44 - Gerrit Code Review

Patch set 1 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/26363

#27 - 2013-12-12 23:03 - Gerrit Code Review

Patch set 2 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/26363

#28 - 2013-12-13 12:12 - Stefan Neufeind

PHP 5.5.7 has just been released. But if I see a fix for our problem in the changelog :-(
http://www.php.net/ChangeLog-5.php#5.5.7
#29 - 2013-12-13 22:46 - Gerrit Code Review

Patch set 3 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/26363

#30 - 2013-12-14 00:45 - Gerrit Code Review

Patch set 4 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/26363

#31 - 2013-12-14 00:57 - Gerrit Code Review

Patch set 5 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/26363

#32 - 2013-12-14 18:05 - Philipp Gampe

another place for 4.5:
/typo3/sysext/em/classes/repository/class.tx_em_repository_utility.php

#33 - 2013-12-14 22:24 - Gerrit Code Review

Patch set 1 for branch TYPO3_6-1 of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/26413

#34 - 2013-12-14 22:24 - Gerrit Code Review

Patch set 1 for branch TYPO3_6-0 of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/26414

#35 - 2013-12-14 22:30 - Helmut Hummel
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:6eb7a548125a945316f8ad32eb3e5481a28ae2d6.

#36 - 2013-12-14 23:35 - Gerrit Code Review
- Status changed from Resolved to Under Review

Patch set 1 for branch TYPO3_4-7 of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/26416

#37 - 2014-01-04 16:46 - Gerrit Code Review
Patch set 2 for branch TYPO3_6-1 of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/26413

#38 - 2014-01-04 16:50 - Gerrit Code Review

Patch set 2 for branch TYPO3_6-0 of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/26414

#39 - 2014-01-04 17:03 - Gerrit Code Review

Patch set 2 for branch TYPO3_4-7 of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/26416

#40 - 2014-01-04 17:09 - Gerrit Code Review

Patch set 3 for branch TYPO3_4-7 of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/26416

#41 - 2014-01-04 17:12 - Gerrit Code Review

Patch set 4 for branch TYPO3_4-7 of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/26416

#42 - 2014-01-04 17:14 - Gerrit Code Review

Patch set 1 for branch TYPO3_4-5 of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/26643

#43 - 2014-01-04 17:30 - Helmut Hummel
- Status changed from Under Review to Resolved

Applied in changeset commit:dd187dd1b3bb2e38ed7dd989efd1055f053cd880.

#44 - 2014-01-04 17:36 - Markus Klein
- Status changed from Resolved to Under Review

Still the 4.7 and 4.5 patches are pending

#45 - 2014-01-17 09:30 - Helmut Hummel
- Status changed from Under Review to Resolved

Applied in changeset commit:2526bddb5b27ca832575fad809facfa39c7db225.
#46 - 2014-10-14 14:04 - Claas Hilbrecht

Helmut Hummel wrote:

Applied in changeset commit:2526bddb5b27ca832575fad809facfa39c7db225.

The changeset was removed with ab6256f from 4.5LTS and is not included anymore (and it seems no other patch that fixes the originating problem). I
cherry-picked the patch and it seems to work but I wonder why it was removed without any other fix?

2014-01-17  ab6256f                  Revert "[TASK] Optimize speed for instantiating class with arguments" (Ernesto Baschny)
2014-01-17  2526bdd  #53682          [TASK] Optimize speed for instantiating class with arguments (Helmut Hummel)

#47 - 2014-10-14 14:13 - Helmut Hummel

Claas Hilbrecht wrote:

2014-01-17  ab6256f                  Revert "[TASK] Optimize speed for instantiating class with arguments" (Ernesto Baschny)

It was reverted (only) because of a compatibility issue with PHP 5.2 (see: https://review.typo3.org/#/c/26910/)

I would be in favor of getting this in again with self:: instead of static:: for 4.5

#48 - 2014-10-14 14:18 - Gerrit Code Review
- Status changed from Resolved to Under Review

Patch set 1 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/33307

#49 - 2014-10-14 14:22 - Gerrit Code Review

Patch set 1 for branch TYPO3_4-5 of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/33308

#50 - 2014-10-14 14:58 - Claas Hilbrecht

Gerrit Code Review wrote:

Patch set 1 for branch TYPO3_4-5 of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/33308

Hello Helmut,

thanks for the really quick fix, I owe you a beer next time we meet ;)
#51 - 2014-10-14 23:30 - Helmut Hummel
- Status changed from Under Review to Resolved

Applied in changeset commit:5c8081ad4487a66bad333149c65fe706106ad938.

#52 - 2014-10-22 12:12 - Markus Klein

This introduced a regression in 4.5; The change is not PHP 5.2 (!) compatible, see #62391

Files
test.php 704 Bytes 2013-11-27 Chris Zepernick
php-5.5.6.patch 7.1 kB 2013-12-07 Philipp Gampe
